﻿'Imports System.Reflection 'you need this line to use Assembly and Activator
Public Class Form1


    'Copyright © ~blaze~ 2011
    Public Class SoundGenerator
        Private strmStream As IO.Stream
        Private rwfcsChunkSettings As RiffWaveFmtChunkSettings
        Private bwWriter As IO.BinaryWriter
        Private lngLengthOffset As Long
        Private lngDataLengthOffset As Long
        Private intCurrentLength As Integer

        Public ReadOnly Property ChunkSettings() As RiffWaveFmtChunkSettings
            Get
                Return rwfcsChunkSettings
            End Get
        End Property

        Public Sub New(ByVal destination As IO.Stream, ByVal bufferSettings As RiffWaveFmtChunkSettings)
            strmStream = destination
            rwfcsChunkSettings = bufferSettings
            bwWriter = New IO.BinaryWriter(destination)
            bwWriter.Write(1179011410I) '"RIFF" schreiben
            'Ermitteln der Position, an der die Laenge der gesamten Datei steht
            lngLengthOffset = destination.Position
            bwWriter.Write(32I) '32 für die aktuelle Datenlänge in Bytes setzen
            bwWriter.Write(1163280727I) '"WAVE" schreiben

            'fmt -Chunk
            bwWriter.Write(544501094I) '"fmt " schreiben
            bwWriter.Write(16I) 'restliche Länge des Blocks setzen
            bwWriter.Write(bufferSettings.FormatTag)
            bwWriter.Write(bufferSettings.NumberChanels)
            bwWriter.Write(bufferSettings.SampleRate)
            bwWriter.Write(bufferSettings.BytesPerSecond)
            bwWriter.Write(bufferSettings.BlockAlign)
            bwWriter.Write(bufferSettings.BitsPerSample)

            'data-Chunk
            bwWriter.Write(1635017060I) '"data" schreiben
            'ermitteln der Position, an der die Laenge des Data-Chunks steht
            lngDataLengthOffset = destination.Position
            bwWriter.Write(0I)
        End Sub

        Public Sub Append(ByVal elongations() As Byte)
            If rwfcsChunkSettings.BitsPerSample = 8S Then
                Dim dataPos As Long = strmStream.Position
                Dim data(Buffer.ByteLength(elongations) - 1) As Byte
                Buffer.BlockCopy(elongations, 0, data, 0, data.Length) 'Inhalt aus Elongations in data kopieren

                strmStream.Seek(lngLengthOffset, IO.SeekOrigin.Begin)
                bwWriter.Write(intCurrentLength + data.Length + 32I)

                strmStream.Seek(lngDataLengthOffset, IO.SeekOrigin.Begin)
                bwWriter.Write(intCurrentLength + data.Length)

                strmStream.Seek(dataPos, IO.SeekOrigin.Begin)
                bwWriter.Write(data)
            Else
                Throw New FormatException("The current sound generator does not support elongations of the type System.Byte.")
            End If
        End Sub

        Public Sub Append(ByVal elongations() As Short)
            If rwfcsChunkSettings.BitsPerSample = 16S Then
                Dim dataPos As Long = strmStream.Position
                Dim data(Buffer.ByteLength(elongations) - 1) As Byte
                Buffer.BlockCopy(elongations, 0, data, 0, data.Length) 'Inhalt aus Elongations in data kopieren

                strmStream.Seek(lngLengthOffset, IO.SeekOrigin.Begin)
                bwWriter.Write(intCurrentLength + data.Length + 32I)

                strmStream.Seek(lngDataLengthOffset, IO.SeekOrigin.Begin)
                bwWriter.Write(intCurrentLength + data.Length)

                strmStream.Seek(dataPos, IO.SeekOrigin.Begin)
                bwWriter.Write(data)
            Else
                Throw New FormatException("The current sound generator does not support elongations of the type System.Int16.")
            End If
        End Sub

        Public Sub Append(ByVal elongations() As Integer)
            If rwfcsChunkSettings.BitsPerSample = 16I Then
                Dim dataPos As Long = strmStream.Position
                Dim data(Buffer.ByteLength(elongations) - 1) As Byte
                Buffer.BlockCopy(elongations, 0, data, 0, data.Length) 'Inhalt aus Elongations in data kopieren

                strmStream.Seek(lngLengthOffset, IO.SeekOrigin.Begin)
                bwWriter.Write(intCurrentLength + data.Length + 32I)

                strmStream.Seek(lngDataLengthOffset, IO.SeekOrigin.Begin)
                bwWriter.Write(intCurrentLength + data.Length)

                strmStream.Seek(dataPos, IO.SeekOrigin.Begin)
                bwWriter.Write(data)
            Else
                Throw New FormatException("The current sound generator does not support elongations of the type System.Int32.")
            End If
        End Sub

        Public Sub Append(Of T)(ByVal elongations() As T)
            Dim tp As Type = GetType(T) 'Typ der Arrayelemente
            Dim vtSize As Integer = Runtime.InteropServices.Marshal.SizeOf(tp) 'Groesse eines Wertetyps
            Dim attributes() As Runtime.InteropServices.StructLayoutAttribute = DirectCast(tp.GetCustomAttributes(GetType(Runtime.InteropServices.StructLayoutAttribute), False), Runtime.InteropServices.StructLayoutAttribute())
            If Not tp.IsValueType AndAlso (attributes.Length <> 1 OrElse attributes(0).Value = Runtime.InteropServices.LayoutKind.Auto) Then
                'Layout von T muss klar definiert sein, bzw. T muss ein Wertetyp sein
                Throw New ArgumentException("T is not a value type or its System.Runtime.InteropServices.StructLayoutAttribute is not specified in a correct way. System.Runtime.InteropServices.StructLayoutAttribute.Value mustnot be System.Runtime.InteropServices.LayoutKind.Auto.")
            Else
                If rwfcsChunkSettings.BitsPerSample = vtSize * 8 Then
                    Dim dataPos As Long = strmStream.Position
                    Dim data(Buffer.ByteLength(elongations) - 1) As Byte
                    'Inhalt aus Elongations in data kopieren, Achtung: keine Arraylaenge ueber Int32.MaxValue moeglich, da
                    'System.Runtime.InteropServices.Marshal.UnsafeAddrOfPinnedArrayElement keine Int64 als Parameter unterstuetzt
                    For i As Integer = 0I To elongations.Length - 1I
                        Runtime.InteropServices.Marshal.Copy(Runtime.InteropServices.Marshal.UnsafeAddrOfPinnedArrayElement(elongations, i), data, vtSize * i, vtSize)
                    Next
                    'Laengen updaten
                    strmStream.Seek(lngLengthOffset, IO.SeekOrigin.Begin)
                    bwWriter.Write(intCurrentLength + data.Length + 32I)

                    strmStream.Seek(lngDataLengthOffset, IO.SeekOrigin.Begin)
                    bwWriter.Write(intCurrentLength + data.Length)

                    'Daten schreiben
                    strmStream.Seek(dataPos, IO.SeekOrigin.Begin)
                    bwWriter.Write(data)
                Else
                    Throw New FormatException(String.Format("The current sound generator does not support elongations of the type {0}.", tp.FullName))
                End If
            End If
        End Sub

        Public Sub AppendSine(ByVal frequency As Double, ByVal amplitude As SByte, ByVal duration As TimeSpan)
            If rwfcsChunkSettings.BitsPerSample = 8I Then
                Dim samples() As Byte = DirectCast(Array.CreateInstance(GetType(Byte), CLng(rwfcsChunkSettings.SampleRate / frequency)), Byte())
                Dim data() As Byte
                Dim count As Double = duration.TotalSeconds * frequency
                Dim dataPos As Long
                Dim len As Integer

                For l As Long = 0L To samples.LongLength - 1L
                    samples.SetValue(CByte(128 + CSByte(amplitude * Math.Sin(2 * l * Math.PI * frequency / rwfcsChunkSettings.SampleRate))), l)
                Next

                data = DirectCast(Array.CreateInstance(GetType(Byte), Buffer.ByteLength(samples)), Byte())
                Buffer.BlockCopy(samples, 0, data, 0, data.Length)
                dataPos = strmStream.Position

                len = CInt(data.Length * count)

                'Laengen updaten
                strmStream.Seek(lngLengthOffset, IO.SeekOrigin.Begin)
                bwWriter.Write(intCurrentLength + len + 32I)

                strmStream.Seek(lngDataLengthOffset, IO.SeekOrigin.Begin)
                bwWriter.Write(intCurrentLength + len)

                For l As Long = 1L To CLng(Math.Floor(count))
                    bwWriter.Write(data)
                Next
                bwWriter.Write(data, 0, CInt(data.Length * (count Mod 1)))
            Else
                Throw New FormatException("The current sound generator does not support elongations of the type System.SByte.")
            End If
        End Sub

        Public Sub AppendSine(ByVal frequency As Double, ByVal amplitude As Short, ByVal duration As TimeSpan)
            If rwfcsChunkSettings.BitsPerSample = 16I Then
                Dim samples() As Short = DirectCast(Array.CreateInstance(GetType(Short), CLng(rwfcsChunkSettings.SampleRate / frequency)), Short())
                Dim data() As Byte
                Dim count As Double = duration.TotalSeconds * frequency
                Dim dataPos As Long
                Dim len As Integer


                For l As Long = 0L To samples.LongLength - 1L
                    samples.SetValue(CShort(amplitude * Math.Sin(2 * l * Math.PI * frequency / rwfcsChunkSettings.SampleRate)), l)
                Next
                data = DirectCast(Array.CreateInstance(GetType(Byte), Buffer.ByteLength(samples)), Byte())
                Buffer.BlockCopy(samples, 0, data, 0, data.Length)
                dataPos = strmStream.Position

                len = CInt(data.Length * count)


                'Laengen updaten
                strmStream.Seek(lngLengthOffset, IO.SeekOrigin.Begin)
                bwWriter.Write(intCurrentLength + len + 32I)

                strmStream.Seek(lngDataLengthOffset, IO.SeekOrigin.Begin)
                bwWriter.Write(intCurrentLength + len)

                For l As Long = 1L To CLng(Math.Floor(count))
                    bwWriter.Write(data)
                Next
                bwWriter.Write(data, 0, CInt(data.Length * (count Mod 1)))
            Else
                Throw New FormatException("The current sound generator does not support elongations of the type System.Int16.")
            End If
        End Sub

        Public Sub AppendSine(ByVal frequency As Double, ByVal amplitude As Integer, ByVal duration As TimeSpan)
            If rwfcsChunkSettings.BitsPerSample = 16I Then
                Dim samples() As Integer = DirectCast(Array.CreateInstance(GetType(Integer), CLng(rwfcsChunkSettings.SampleRate / frequency)), Integer())
                Dim data() As Byte
                Dim count As Double = duration.TotalSeconds * frequency
                Dim dataPos As Long
                Dim len As Integer


                For l As Long = 0L To samples.LongLength - 1L
                    samples.SetValue(CInt(amplitude * Math.Sin(2 * l * Math.PI * frequency / rwfcsChunkSettings.SampleRate)), l)
                Next
                data = DirectCast(Array.CreateInstance(GetType(Byte), Buffer.ByteLength(samples)), Byte())
                Buffer.BlockCopy(samples, 0, data, 0, data.Length)
                dataPos = strmStream.Position

                len = CInt(data.Length * count)

                'Laengen updaten
                strmStream.Seek(lngLengthOffset, IO.SeekOrigin.Begin)
                bwWriter.Write(intCurrentLength + len + 32I)

                strmStream.Seek(lngDataLengthOffset, IO.SeekOrigin.Begin)
                bwWriter.Write(intCurrentLength + len)

                For l As Long = 1L To CLng(Math.Floor(count))
                    bwWriter.Write(data)
                Next
                bwWriter.Write(data, 0, CInt(data.Length * (count Mod 1)))
            Else
                Throw New FormatException("The current sound generator does not support elongations of the type System.Int32.")
            End If
        End Sub
    End Class

    Public Structure RiffWaveFmtChunkSettings
        Public FormatTag As Short
        Public NumberChanels As Short
        Public SampleRate As Integer
        Public BitsPerSample As Short

        Public ReadOnly Property BlockAlign() As Short
            Get
                Return NumberChanels * BitsPerSample \ 8S
            End Get
        End Property

        Public ReadOnly Property BytesPerSecond() As Integer
            Get
                Return SampleRate * NumberChanels * BitsPerSample \ 8I
            End Get
        End Property

        Public Sub New(ByVal formatTag As Short, ByVal numberChanels As Short, ByVal sampleRate As Integer, ByVal bitsPerSample As Short)
            Me.FormatTag = formatTag
            Me.NumberChanels = numberChanels
            Me.SampleRate = sampleRate
            Me.BitsPerSample = bitsPerSample
        End Sub
    End Structure



    Private Sub TextBox1_TextChanged(sender As System.Object, e As System.EventArgs)

    End Sub


    Private Sub TrackBar2_Scroll(sender As System.Object, e As System.EventArgs) Handles TrackBar2.Scroll
        TextBox2.Text = TrackBar2.Value & " Sec."
    End Sub

    Private Sub TrackBar3_Scroll(sender As System.Object, e As System.EventArgs) Handles TrackBar3.Scroll
        TextBox3.Text = TrackBar3.Value & " Sec."
    End Sub

    Private Sub TrackBar4_Scroll(sender As System.Object, e As System.EventArgs) Handles TrackBar4.Scroll
        TextBox4.Text = TrackBar4.Value & " Sec."
    End Sub

    Private Sub TrackBar5_Scroll(sender As System.Object, e As System.EventArgs) Handles TrackBar5.Scroll
        TextBox5.Text = TrackBar5.Value & " Sec."
    End Sub

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        Dim stream As New IO.MemoryStream
        Dim generator As New SoundGenerator(stream, New RiffWaveFmtChunkSettings(1S, 2S, 44100I, 16S))
        Dim soundPlayer As New Media.SoundPlayer

        Dim freq As Int32
        freq = 5

        generator.AppendSine(freq, Short.MaxValue, TimeSpan.FromMilliseconds(Integer.Parse(TrackBar2.Value) * 1000))
        stream.Seek(0, IO.SeekOrigin.Begin)
        soundPlayer.Stream = stream
        soundPlayer.Play() 'PlaySync, etc.
    End Sub

    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
        Dim stream2 As New IO.MemoryStream
        Dim generator2 As New SoundGenerator(stream2, New RiffWaveFmtChunkSettings(1S, 2S, 44100I, 16S))
        Dim soundPlayer2 As New Media.SoundPlayer

        Dim freq As Int32
        freq = 82.4069

        generator2.AppendSine(freq, Short.MaxValue, TimeSpan.FromMilliseconds(Integer.Parse(TrackBar3.Value) * 1000))
        stream2.Seek(0, IO.SeekOrigin.Begin)
        soundPlayer2.Stream = stream2
        soundPlayer2.Play() 'PlaySync, etc.
    End Sub

    Private Sub Button3_Click(sender As System.Object, e As System.EventArgs) Handles Button3.Click
        Dim stream3 As New IO.MemoryStream
        Dim generator3 As New SoundGenerator(stream3, New RiffWaveFmtChunkSettings(1S, 2S, 44100I, 16S))
        Dim soundPlayer3 As New Media.SoundPlayer

        Dim freq As Int32
        freq = 100

        generator3.AppendSine(freq, Short.MaxValue, TimeSpan.FromMilliseconds(Integer.Parse(TrackBar4.Value) * 1000))
        stream3.Seek(0, IO.SeekOrigin.Begin)
        soundPlayer3.Stream = stream3
        soundPlayer3.Play() 'PlaySync, etc.
    End Sub

    Private Sub Button4_Click(sender As System.Object, e As System.EventArgs) Handles Button4.Click
        Dim stream As New IO.MemoryStream
        Dim generator As New SoundGenerator(stream, New RiffWaveFmtChunkSettings(1S, 2S, 44100I, 16S))
        Dim soundPlayer As New Media.SoundPlayer

        Dim freq As Int32
        freq = 200

        generator.AppendSine(freq, Short.MaxValue, TimeSpan.FromMilliseconds(Integer.Parse(TrackBar5.Value) * 1000))
        stream.Seek(0, IO.SeekOrigin.Begin)
        soundPlayer.Stream = stream
        soundPlayer.Play() 'PlaySync, etc.

      
    End Sub

    ' Create Fluidsynth sounds with soundfonts http://sourceforge.net/apps/trac/fluidsynth/

    Private Sub Button5_Click(sender As System.Object, e As System.EventArgs) Handles Button5.Click
        Dim fluidSettings As New FluidSynthWrapper.Settings
        ' Set some settings for use with the audio driver, in this case, to use Windows DirectSound for output
        fluidSettings.AudioDriver = "dsound"
        ' Set some settings for the synthesizer
        fluidSettings.SynthAudioChannels = 16 ' This sets the number of MIDI channels available for use (defaulted to 16)
        fluidSettings.SynthSampleRate = 44100 ' The audio sample rate sent to the audio driver


        Dim synth As New FluidSynthWrapper.Synthesizer(fluidSettings) ' Create the synthesizer with the settings
        Dim audioDrv As New FluidSynthWrapper.AudioDriver(fluidSettings, synth) ' Create the audio driver width the settings and connected to the synthesizer

        ' load soundfont files
        ' Thats a bass guitar
        Dim path As String = "sounds\BassFing.sf2"
        ' Thats a Piano
        'Dim path As String = "sounds\gorts.sf2"
        'Thats a Drum Kit
        'Dim path As String = "sounds\StomperSet.sf2"
        'Thats a synthesizer
        'Dim path As String = "sounds/198_Juno_StringPad.sf2"
        'Dim path As String = ""
        If FluidSynthWrapper.Synthesizer.IsSoundFont(path) Then
            Dim sfontId As Integer = synth.SFontLoad(path)
            ' Play the music
            'synth.SFontUnload(path, True)

            ' Set the first channel to the grand piano instrument (which is the default anyway)
            synth.ProgChange(0, 0)

            ' Hold for one second
            'System.Threading.Thread.Sleep(1000)
            ' Stop playing the note
            'synth.NoteOff(0, 60)

            ' Play middle C (Midi key 60. See midi key maps)

            fluidSettings.SynthGain = 0.2 ' volume
            synth.NoteOn(0, 60, 127)
            System.Threading.Thread.Sleep(1000)
            synth.NoteOff(0, 60)

            fluidSettings.SynthGain = 0.2
            synth.NoteOn(0, 61, 127)
            System.Threading.Thread.Sleep(1000)
            synth.NoteOff(0, 61)

            synth.NoteOn(0, 62, 127)
            System.Threading.Thread.Sleep(1000)
            synth.NoteOff(0, 62)

            synth.NoteOn(0, 63, 127)
            System.Threading.Thread.Sleep(1000)
            synth.NoteOff(0, 63)

            synth.NoteOn(0, 64, 127)
            ' Hold for two second
            System.Threading.Thread.Sleep(2000)
            ' Stop playing the note
            synth.NoteOff(0, 64)

        Else
            MsgBox("error - can not load")

        End If
    End Sub

    Private Sub Button7_Click(sender As System.Object, e As System.EventArgs) Handles Button7.Click
        Dim fluidSettings As New FluidSynthWrapper.Settings
        ' Set some settings for use with the audio driver, in this case, to use Windows DirectSound for output
        fluidSettings.AudioDriver = "dsound"
        ' Set some settings for the synthesizer
        ' See how to get LOW LATENCY for realtime playback http://sourceforge.net/apps/trac/fluidsynth/wiki/LowLatency

        fluidSettings.SynthAudioChannels = 16 ' This sets the number of MIDI channels available for use (defaulted to 16)
        fluidSettings.SynthSampleRate = 44100 ' The audio sample rate sent to the audio driver
        'fluidSettings.AudioPeriods = 32       ' Set the number of audio buffers

        Dim synth As New FluidSynthWrapper.Synthesizer(fluidSettings) ' Create the synthesizer with the settings
        Dim audioDrv As New FluidSynthWrapper.AudioDriver(fluidSettings, synth) ' Create the audio driver width the settings and connected to the synthesizer

        ' load soundfont files
        ' Thats a bass guitar
        'Dim path As String = "sounds\BassFing.sf2"
        ' Thats a Piano
        Dim path As String = "sounds\gorts.sf2"
        'Thats a Drum Kit
        'Dim path As String = "sounds\StomperSet.sf2"
        'Thats a synthesizer
        'Dim path As String = "sounds/198_Juno_StringPad.sf2"
        'Dim path As String = ""
        If FluidSynthWrapper.Synthesizer.IsSoundFont(path) Then
            Dim sfontId As Integer = synth.SFontLoad(path)

            ' Play the music (deprecated)
            'synth.SFontUnload(path, True)

            ' Set the first channel to the grand piano instrument (which is the default anyway)
            synth.ProgChange(0, 0)

            ' Hold for one second
            'System.Threading.Thread.Sleep(1000)
            ' Stop playing the note
            'synth.NoteOff(0, 60)

            ' Play middle C (Midi key 60. See midi key maps http://www.sengpielaudio.com/Rechner-notennamen.htm
            ' Documentation http://sourceforge.net/apps/trac/fluidsynth/wiki/Documentation
            'Dim CompleteCounter As Integer = 0 'seconds
            Dim ToneCounter As Double = 1 'interval
            Dim Duration As Integer ' Duration of a tone in ms
            Dim freq As Integer 'Freq of a tone in midi key 20-60
            Dim selectedTime As Integer 'maximum play time in sec

            freq = frequenzTrackbar.Value
            Duration = selectDuration.Value
            selectedTime = SelectTime.Value
            'MsgBox(selectedTime)


            Do
                fluidSettings.SynthGain = 5.0 ' volume 	Min-Max	0.0-10.0 Default: 0.2

                synth.NoteOn(0, freq, 100) ' 20 = tone e on keyboard
                System.Threading.Thread.Sleep(Duration) ' Duration
                'fade out tone
                synth.NoteOff(0, freq)
                'turn hard off the tone
                'synth.Reset()

                Console.WriteLine("ToneCounter=" & ToneCounter)
                ToneCounter += 1

            Loop Until ToneCounter = Math.Round((1000 / Duration) * selectedTime, 0)
     
        Else
            MsgBox("error - can not load soundfont")

        End If
    End Sub


    Private Sub Button8_Click(sender As System.Object, e As System.EventArgs) Handles Button8.Click
        Dim counter As Integer = 0
        Do
           
            Dim stream3 As New IO.MemoryStream
            Dim generator3 As New SoundGenerator(stream3, New RiffWaveFmtChunkSettings(1S, 2S, 44100I, 16S))
            Dim soundPlayer3 As New Media.SoundPlayer

            Dim freq As Int32
            freq = 82

            generator3.AppendSine(freq, Short.MaxValue, TimeSpan.FromMilliseconds(Integer.Parse(TrackBar4.Value) * 1000))
            stream3.Seek(0, IO.SeekOrigin.Begin)
            soundPlayer3.Stream = stream3
            soundPlayer3.Play() 'PlaySync, etc.

            Console.WriteLine("Schleife")
            counter += 1
            System.Threading.Thread.Sleep(200)
        Loop Until counter = 10
    End Sub

    Private Sub GroupBox1_Enter(sender As System.Object, e As System.EventArgs) Handles GroupBox1.Enter

    End Sub



    Private Sub SelectTime_Scroll(sender As System.Object, e As System.EventArgs) Handles SelectTime.Scroll
        Dim time As Integer
        time = Me.SelectTime.Value
        'MessageBox.Show(time)

        txtTotalTime.Text = time & "sec."
    End Sub

    Private Sub frequenzTrackbar_Scroll(sender As System.Object, e As System.EventArgs) Handles frequenzTrackbar.Scroll
        txtInt.Text = frequenzTrackbar.Value

    End Sub

    Private Sub selectDuration_Scroll(sender As System.Object, e As System.EventArgs) Handles selectDuration.Scroll
        txtDuration.Text = selectDuration.Value & " ms"
    End Sub
End Class

